
#ifndef ROOT_TCutG
#define ROOT_TCutG

//////////////////////////////////////////////////////////////////////////
//                                                                      //
// TCutG                                                                //
//                                                                      //
// A Graphical cut.                                                     //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#ifndef ROOT_TGraph
//*KEEP,TGraph.
#include "TGraph.h"
//*KEND.
#endif

class TCutG : public TGraph {

protected:
   TString      fVarX;         //X variable
   TString      fVarY;         //Y variable
   TObject     *fObjectX;      //pointer to an object corresponding to X
   TObject     *fObjectY;      //pointer to an object corresponding to Y

public:
   TCutG();
   TCutG(const Text_t *name, Int_t n, Float_t *x=0, Float_t *y=0);
   virtual ~TCutG();
   TObject       *GetObjectX() {return fObjectX;}
   TObject       *GetObjectY() {return fObjectY;}
   const Text_t  *GetVarX() const {return fVarX.Data();}
   const Text_t  *GetVarY() const {return fVarY.Data();}
   virtual Int_t  IsInside(Float_t x, Float_t y);
   virtual void   SavePrimitive(ofstream &out, Option_t *option);
   virtual void   SetObjectX(TObject *obj) {fObjectX = obj;}
   virtual void   SetObjectY(TObject *obj) {fObjectY = obj;}
   virtual void   SetVarX(const Text_t *varx); // *MENU*
   virtual void   SetVarY(const Text_t *vary); // *MENU*

   ClassDef(TCutG,1)  // A Graphical cut.
};

#endif
